<?php
Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "partner_site_queue".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PartnerSiteQueue".
 *
 * Columns in table "partner_site_queue" available as properties of the model,
 * followed by relations of table "partner_site_queue" available as properties of the model.
 *
 * @property integer $id
 * @property integer $partner_site_id
 * @property integer $completed
 * @property string $external_id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property string $date_added
 * @property string $notes
 *
 * @property PartnerSite $partnerSite
 * @property Provider $provider
 * @property Practice $practice
 */
abstract class BasePartnerSiteQueue extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'partner_site_queue';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PartnerSiteQueue|PartnerSiteQueues', $n);
    }

    public static function representingColumn()
    {
        return 'external_id';
    }

    public function rules()
    {
        return array(
            array(
                'external_id',
                'required'
            ),
            array(
                'partner_site_id, completed, practice_id, provider_id',
                'numerical',
                'integerOnly' => true
            ),
            array(
                'external_id',
                'length',
                'max' => 255
            ),
            array(
                'date_added, notes',
                'safe'
            ),
            array(
                'partner_site_id, completed, practice_id, provider_id, date_added, notes',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, partner_site_id, completed, external_id, practice_id, provider_id, date_added, notes',
                'safe',
                'on' => 'search'
            )
        );
    }

    public function relations()
    {
        return array(
            'partnerSite' => array(
                self::BELONGS_TO,
                'PartnerSite',
                'partner_site_id'
            ),
            'provider' => array(
                self::BELONGS_TO,
                'Provider',
                'provider_id'
            ),
            'practice' => array(
                self::BELONGS_TO,
                'Practice',
                'practice_id'
            )
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_site_id' => null,
            'completed' => Yii::t('app', 'Completed'),
            'external_id' => Yii::t('app', 'External'),
            'practice_id' => null,
            'provider_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'notes' => Yii::t('app', 'Notes'),
            'partnerSite' => null,
            'provider' => null,
            'practice' => null
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('id', $this->id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('completed', $this->completed);
        $criteria->compare('external_id', $this->external_id, true);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('notes', $this->notes, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria
        ));
    }
}
